# Final Exam

1. Briefly describe how the minimum spanning tree-based segmentation works. 
   Please describe the algorithm at high-level (don't describe the code). 
   Keep the answer to a paragraph or two; be brief and to the point.




---


2. Carefully inspect the `addAllEdges` method. 
   "It seems that each edge is added twice to the priority queue." 
   Is this statement true or false. If it is false, state why. 
   If it is true, state why this is not a problem (not a bug).



----


3. Carefully inspect the `kruskal` method. 
   "It seems the implementation of kruskal is missing the step to check for cycles and avoid it." 
   Is this statement true or false. If it is false, state why. 
   If it is true, state why this is not a problem (not a bug).


----


4. Consider this statement: "Kruskal is a better choice compared to Prim's algorithm for 
   minimum spanning tree-based segmentation." 
   Is this statement true or false. Justify your answer. 
   Keep the answer to a paragraph; be brief and to the point.
   




---


5. Finally, complete the following code snippet and provide the missing running times. 
   Please describe the running time as a function of image width ($w$) and image height ($h$). 
   Assume Java's priority queue is implemented as a binary heap where all core operations are logarithmic. 
   Assume Java's hash table (HashMap) operates under uniform hashing assumption with 
   excellent collision resolution that results in constant time operations!

```java
Color[][] pixels = ImageUtility.getPixels(image); // O(w x h)
PriorityQueue<Edge> edges = addAllEdges(pixels);  // O(?)
UnionFind<Integer> regions = new RasterUnionFindSln(image.getWidth(), image.getHeight()); // O(?)

while (!edges.isEmpty()) { // O(?)
  Edge e = edges.poll();   // O(?)
  regions.union(e.fromPixelID, e.toPixelID);  // O(?)
  if (regions.count() == numberOfDesiredRegions) { // O(?)
    break; // O(?)
  }
}

HashMap<Integer, Color> colors = assignColorToEachRegion(pixels, regions); // O(?)
reColor(image, regions, colors); // O(?)
```
 

---


6. In the implementation of `RasterUnionFind`, we did not incorporate any of the 
   improvements (the union-by-size and path compression). 
   That said, it seems our implementation is performing path compression! 
   For example, consider the output of `ImageRegions` for the `color.png` file:
   Briefly elaborate if this is a lucky incidence or there is any aspect of our implementation 
   which increases the likelihood of this unplanned path compression. 
   Keep the answer to a paragraph; be brief and to the point.